Technical indicators in JavaScript Stock chart control

18 Nov 201811 minutes to read

A technical indicator is a mathematical calculation based on historic price, volume or open interest information that aims to forecast financial market direction.

StockChart supports 10 types of technical indicators namely Accumulation Distribution, ATR, EMA,SMA,TMA,Momentum,MACD,RSI,Stochastic,Bollinger Band. By using indicator dropdown box you can add an remove the required indicators types.

Accumulation Distribution

Accumulation Distribution combines price and volume to show how money may be flowing into or out of stock. To render a Accumulation Distribution Indicator, use indicator type as AccumulationDistribution and inject
AccumulationDistributionIndicator module using StockChart.Inject(AccumulationDistributionIndicator). To calculate the signal line volume field is additionally added with dataSource.

Average True Range (ATR)

ATR measures the stock volatility by comparing the current value with the previous value. To render a Average True Range (ATR) Indicator,
use indicator type as Atr and inject AtrIndicator module using StockChart.Inject(AtrIndicator).

Exponential Moving Average (EMA)

Moving average Indicators are used to define the direction of the trend. To render a EMA Indicator, use indicator type as Ema and inject EmaIndicator module using StockChart.Inject(EmaIndicator).

Momentum

Momentum shows the speed at which the price of the stock is changing. To render a Momentum indicator, use indicator type as Momentumand inject MomentumIndicator module using StockChart.Inject(MomentumIndicator) method. Momentum indicator will be represented by two lines (upperLine, signalLine).In momentum indicator the upperBand value is always renders at the value 100.

Moving Average Convergence Divergence (MACD)

MACD is based on the difference between two EMA’s. To render a MACD Indicator, use indicator type as Macd and inject MacdIndicator module using StockChart.Inject(MacdIndicator).MACD indicator will be represented by MACD line,signal line, MACD histogram. MACD histogram is used to differentiate MACD line and signal line.

Relative Strength Index (RSI)

RSI shows how strongly a stock is moving in its current direction. To render a RSI Indicator, use indicator type as Rsi and inject RsiIndicator module using StockChart.Inject(Rsindicator).RSI indicator will be represented
by three lines (upperBand, lowerBand, signalLine). The upperBand and lowerBand values are customized by overBought and overSold properties of indicator and the signalLine is calculated by RSI formula.

Simple Moving Average (SMA)

Moving average Indicators are used to define the direction of the trend. To render a SMA Indicator, use indicator type as Sma and inject SmaIndicator module using StockChart.Inject(SmaIndicator).

Stochastic

It shows how a stock is, when compared to previous state. To render a Stochastic indicator, use indicator type as Stochastic and inject StochasticIndicator module using StockChart.Inject(StochasticIndicator) method.
stochastic indicator will be represented by four lines (upperLine, lowerLine, periodLine, signalLine). In stochastic indicator the upperBand value and lowerBand value is customized by overBought and overSold properties of indicators and the periodLine and signalLine is render based on stochastic formula.

Triangular Moving Average (TMA)

Moving average Indicators are used to define the direction of the trend. To render a TMA Indicator, use indicator type as Tma and inject TmaIndicator module using StockChart.Inject(TmaIndicator).

Bollinger Band

A StockChart overlay that shows the upper and lower limits of normal price movements based on the standard deviation of prices. To render a Bollinger Band, use indicator type as BollingerBand and inject BollingerBands module using StockChart.Inject(BollingerBands) method. Bollinger band will be represented by three lines (upperLine, lowerLine, signalLine).
The default values of the Bollinger Band period is 14 and standardDeviations is 2.

var stockChart = new ej.charts.StockChart({
    chartArea: { border: { width: 0 } },
    primaryYAxis: {
        lineStyle: { color: 'transparent' },
        majorTickLines: { color: 'transparent', width: 0 },
    },
    border : {width : 0},
    primaryXAxis: { majorGridLines: { color: 'transparent' }, crosshairTooltip: { enable: true } },
    series: [
        {
            dataSource: chartData, name: 'Apple Inc',
            type: 'Candle', bearFillColor: '#00226C', bullFillColor: "#0450C2", fill: 'blue'
        },
    ],
    indicators: [{
        type: 'BollingerBands', field: 'Close', seriesName: 'Apple Inc', xName: 'date', high: 'high', low: 'low', open: 'open', close: 'close',
        period: 10, upperLine: { color: '#ffb735', width: 1 },
        lowerLine: { color: '#f2ec2f', width: 1 }
    }],
    seriesType: [],
    exportType: [],
    trendlineType: [],
    tooltip: {
        enable: true
    },
    crosshair: {
        enable: true
    },
    height: '350',
});
stockChart.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="./index.css" rel="stylesheet">
    <link href="http://cdn.syncfusion.com/ej2/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Indicator Events

The StockChart component supports indicator lifecycle events, allowing you to monitor and control indicator add and remove operations triggered through the built-in toolbar indicator dropdown. These events are useful for validating user actions, restricting specific indicators, tracking indicator changes, and integrating indicator interactions with application logic.

The following indicator events are supported by the StockChart component:

  • beforeIndicatorChange – Fired before an indicator is added or removed. This event allows you to review the requested action in advance and cancel it by setting cancel to true.

  • indicatorChanged – Fired after an indicator has been added or removed successfully. This event occurs only if the action was not canceled and can be used to handle the updated state in your application.

let stockChart = new ej.charts.StockChart({
    title: 'AAPL Stock Price',
    primaryXAxis: {
        valueType: 'DateTime'
    },
    tooltip: { enable: true },
    crosshair: { enable: true },
    series: [
        {
            dataSource: chartData,
            xName: 'date',
            open: 'open',
            high: 'high',
            low: 'low',
            close: 'close',
            volume: 'volume',
            name: 'Apple Inc',
            type: 'Candle'
        }
    ],
    beforeIndicatorChange: (args) => {
        console.log('Before Indicator Change:', args.type);
        // prevent EMA indicator
        if (args.type === 'Ema') {
            args.cancel = true;
        }
    },
    indicatorChanged: (args) => {
        console.log(args.type + ' indicator ' + (args.isAdd ? 'added' : 'removed'));
    }
});

stockChart.appendTo('#element');
<!DOCTYPE html>
<html lang="en">
<head>
    <title>Indicator Events</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="./index.css" rel="stylesheet">
    <link href="http://cdn.syncfusion.com/ej2/material.css" rel="stylesheet">  
    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if(ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>
</html>

Technical indicators in React Stock chart component

18 Nov 201818 minutes to read

A technical indicator is a mathematical calculation based on historic price, volume or open interest information that aims to forecast financial market direction.

StockChart supports 10 types of technical indicators namely Accumulation Distribution, ATR, EMA,SMA,TMA,Momentum,MACD,RSI,Stochastic,Bollinger Band. By using indicator dropdown box you can add an remove the required indicators types.

Accumulation Distribution

Accumulation Distribution combines price and volume to show how money may be flowing into or out of stock. To render a Accumulation Distribution Indicator, use indicator type as AccumulationDistribution and inject AccumulationDistributionIndicator module using <Inject services={[AccumulationDistributionIndicator]}>. To calculate the signal line volume field is additionally added with dataSource.

Average True Range (ATR)

ATR measures the stock volatility by comparing the current value with the previous value. To render a Average True Range (ATR) Indicator, use indicator type as Atr and inject AtrIndicator module using <Inject services={[AtrIndicator]}>.

Exponential Moving Average (EMA)

Moving average Indicators are used to define the direction of the trend. To render a EMA Indicator, use indicator type as Ema and inject EmaIndicator module using <Inject services={[EmaIndicator}]>.

Momentum

Momentum shows the speed at which the price of the stock is changing. To render a Momentum indicator, use indicator type as Momentumand inject MomentumIndicator module using <Inject services={[MomentumIndicator]}> method. Momentum indicator will be represented by two lines (upperLine, signalLine).In momentum indicator the upperBand value is always renders at the value 100.

Moving Average Convergence Divergence (MACD)

MACD is based on the difference between two EMA’s. To render a MACD Indicator, use indicator type as Macd and inject MacdIndicator module using <Inject services={[MacdIndicator]}>.MACD indicator will be represented by MACD line,signal line, MACD histogram. MACD histogram is used to differentiate MACD line and signal line.

Relative Strength Index (RSI)

RSI shows how strongly a stock is moving in its current direction. To render a RSI Indicator, use indicator type as Rsi and inject RsiIndicator module using <Inject services={[Rsindicator]}>.RSI indicator will be represented by three lines (upperBand, lowerBand, signalLine). The upperBand and lowerBand values are customized by overBought and overSoldproperties of indicator and the signalLine is calculated by RSI formula.

Simple Moving Average (SMA)

Moving average Indicators are used to define the direction of the trend. To render a SMA Indicator, use indicator type as Sma and inject SmaIndicator module using <Inject services={[SmaIndicator]}>.

Stochastic

It shows how a stock is, when compared to previous state. To render a Stochastic indicator, use indicator type as Stochastic and inject StochasticIndicator module using Chart.Inject(StochasticIndicator) method. stochastic indicator will be represented by four lines (upperLine, lowerLine, periodLine, signalLine).
In stochastic indicator the upperBand value and lowerBand value is customized by overBought and overSold properties of indicators and the periodLine and signalLine is render based on stochastic formula.

Triangular Moving Average (TMA)

Moving average Indicators are used to define the direction of the trend. To render a TMA Indicator, use indicator type as Tma and inject TmaIndicator module using <Inject services={[TmaIndicator]}>.

Bollinger Band

A StockChart overlay that shows the upper and lower limits of normal price movements based on the standard deviation of prices. To render a Bollinger Band, use indicator type as BollingerBand and inject BollingerBands module using <Inject services={[BollingerBands]}> method. Bollinger band will be represented by three lines (upperLine, lowerLine, signalLine). The default values of the Bollinger Band period is 14 and standardDeviations is 2.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, Inject, DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, StockChartIndicatorsDirective, StockChartIndicatorDirective, LineSeries, SplineSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries } from '@syncfusion/ej2-react-charts';
import { BollingerBands } from '@syncfusion/ej2-react-charts';
import { chartData } from '../datasource';
function App() {
    const upperline = { color: '#ffb735', width: 1 };
    const lowerline = { color: '#f2ec2f', width: 1 };
    return (<StockChartComponent id='stockchart' primaryXAxis={{
            majorGridLines: { color: 'transparent' }, crosshairTooltip: { enable: true }
        }} primaryYAxis={{
            lineStyle: { color: 'transparent' },
            majorTickLines: { color: 'transparent', width: 0 }
        }} crosshair={{ enable: true }} tooltip={{ enable: true }} seriesType={[]} exportType={[]} trendlineType={[]} height='350'>
                <Inject services={[DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, BollingerBands,
            LineSeries, SplineSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries]}/>
                <StockChartSeriesCollectionDirective>
                    <StockChartSeriesDirective dataSource={chartData} type='Candle' name='Apple Inc' bearFillColor='#00226C' bullFillColor="#0450C2" fill='blue'>
                    </StockChartSeriesDirective>
                </StockChartSeriesCollectionDirective>
                <StockChartIndicatorsDirective>
                    <StockChartIndicatorDirective type='BollingerBands' field='Close' seriesName='Apple Inc' fill='#606eff' xName='date' high='high' low='low' open='open' close='close' period={10} upperLine={upperline} lowerLine={lowerline}>
                    </StockChartIndicatorDirective>
                </StockChartIndicatorsDirective>
            </StockChartComponent>);
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, Inject,
    DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, Trendlines, StockChartIndicatorsDirective, StockChartIndicatorDirective, LineSeries, SplineSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries
} from '@syncfusion/ej2-react-charts';
import { BollingerBands } from '@syncfusion/ej2-react-charts';
import { chartData } from '../datasource';

function App() {
        const upperline: Object = { color: '#ffb735', width: 1 };
        const lowerline: Object = { color: '#f2ec2f', width: 1 };
        return (
            <StockChartComponent id='stockchart'
                primaryXAxis={{
                    majorGridLines: { color: 'transparent' }, crosshairTooltip: { enable: true }
                }}
                primaryYAxis={{
                    lineStyle: { color: 'transparent' },
                    majorTickLines: { color: 'transparent', width: 0 }
                }}
                crosshair={{ enable: true }}
                tooltip={{ enable: true }}
                seriesType={[]}
                exportType={[]}
                trendlineType={[]}
                height='350'
            >
                <Inject services={[DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, BollingerBands,
                LineSeries, SplineSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries]} />
                <StockChartSeriesCollectionDirective>
                    <StockChartSeriesDirective dataSource={chartData} type='Candle' name='Apple Inc'
                    bearFillColor='#00226C' bullFillColor="#0450C2" fill='blue'>
                    </StockChartSeriesDirective>
                </StockChartSeriesCollectionDirective>
                <StockChartIndicatorsDirective>
                    <StockChartIndicatorDirective type='BollingerBands' field='Close' seriesName='Apple Inc' fill='#606eff' xName='date' high='high' low='low' open='open' close='close' period={10} upperLine={upperline} lowerLine={lowerline}>
                    </StockChartIndicatorDirective>
                </StockChartIndicatorsDirective >
            </StockChartComponent>
        )
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));

## Indicator Events

The StockChart component supports indicator lifecycle events, allowing you to monitor and control indicator add and remove operations triggered through the built-in toolbar indicator dropdown. These events are useful for validating user actions, restricting specific indicators, tracking indicator changes, and integrating indicator interactions with application logic.

The following indicator events are supported by the StockChart component:

  • beforeIndicatorChange – Fired before an indicator is added or removed. This event allows you to review the requested action in advance and cancel it by setting cancel to true.

  • indicatorChanged – Fired after an indicator has been added or removed successfully. This event occurs only if the action was not canceled and can be used to handle the updated state in your application.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, Inject, DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, LineSeries, SplineSeries,
    AccumulationDistributionIndicator, AtrIndicator, BollingerBands, EmaIndicator, MomentumIndicator, MacdIndicator, RsiIndicator, SmaIndicator, StochasticIndicator, TmaIndicator
} from '@syncfusion/ej2-react-charts';
import { chartData } from '../datasource';

function App() {
    const primaryXAxis = { valueType: 'DateTime'};
    const tooltip = { enable: true };
    const crosshair = { enable: true };
    const beforeIndicatorChange = (args) => {
        console.log('Before Indicator Change:', args.type);
        // Prevent EMA indicator
        if (args.type === 'Ema') {
            args.cancel = true;
        }
    };
    const indicatorChanged = (args) => {
        console.log(`${args.type} indicator ${args.isAdd ? 'added' : 'removed'}`);
    };
    return (
        <StockChartComponent id='stockchart' title='AAPL Stock Price' primaryXAxis={primaryXAxis} tooltip={tooltip} crosshair={crosshair} 
            height='350' beforeIndicatorChange={beforeIndicatorChange} indicatorChanged={indicatorChanged}>
            <Inject services={[ DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, LineSeries, SplineSeries, AccumulationDistributionIndicator, AtrIndicator,
                BollingerBands, EmaIndicator, MomentumIndicator, MacdIndicator, RsiIndicator, SmaIndicator, StochasticIndicator, TmaIndicator ]} />
            <StockChartSeriesCollectionDirective>
                <StockChartSeriesDirective dataSource={chartData} type='Candle' xName='date' open='open' high='high' low='low' 
                    close='close' volume='volume' name='Apple Inc'>
                </StockChartSeriesDirective>
            </StockChartSeriesCollectionDirective>
        </StockChartComponent>
    );
}
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, Inject, DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, LineSeries, SplineSeries,
    AccumulationDistributionIndicator, AtrIndicator, BollingerBands, EmaIndicator, MomentumIndicator, MacdIndicator, RsiIndicator, SmaIndicator, StochasticIndicator, TmaIndicator,
    IBeforeIndicatorChangeEventArgs, IIndicatorChangedEventArgs
} from '@syncfusion/ej2-react-charts';
import { chartData } from '../datasource';

function App() {
    const primaryXAxis: Object = { valueType: 'DateTime' };
    const tooltip: Object = { enable: true };
    const crosshair: Object = { enable: true };
    const beforeIndicatorChange = (args: IBeforeIndicatorChangeEventArgs): void => {
        console.log('Before Indicator Change:', args.type);
        // Prevent EMA indicator
        if (args.type === 'Ema') {
            args.cancel = true;
        }
    };
    const indicatorChanged = (args: IIndicatorChangedEventArgs): void => {
        console.log(`${args.type} indicator ${args.isAdd ? 'added' : 'removed'}`);
    };
    return (
        <StockChartComponent id='stockchart' title='AAPL Stock Price' primaryXAxis={primaryXAxis} tooltip={tooltip} crosshair={crosshair}
            height='350' beforeIndicatorChange={beforeIndicatorChange} indicatorChanged={indicatorChanged}>
            <Inject services={[ DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, LineSeries, SplineSeries, AccumulationDistributionIndicator, AtrIndicator,
                BollingerBands, EmaIndicator, MomentumIndicator, MacdIndicator, RsiIndicator, SmaIndicator, StochasticIndicator, TmaIndicator ]} />
            <StockChartSeriesCollectionDirective>
                <StockChartSeriesDirective dataSource={chartData} type='Candle' xName='date' open='open' high='high' low='low'
                    close='close' volume='volume' name='Apple Inc'>
                </StockChartSeriesDirective>
            </StockChartSeriesCollectionDirective>
        </StockChartComponent>
    );
}
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));

Technical indicators in Angular Stock chart component

18 Nov 201810 minutes to read

A technical indicator is a mathematical calculation based on historic price, volume or open interest information that aims to forecast financial market direction.

StockChart supports 10 types of technical indicators namely Accumulation Distribution, ATR, EMA,SMA,TMA,Momentum,MACD,RSI,Stochastic,Bollinger Band. By using indicator dropdown box you can add an remove the required indicators types.

Accumulation Distribution

Accumulation Distribution combines price and volume to show how money may be flowing into or out of stock.
To render a Accumulation Distribution Indicator, use indicator type as AccumulationDistribution and inject AccumulationDistributionIndicatorService into the @NgModule.providers.
To calculate the signal line volume field is additionally added with dataSource.

Average True Range (ATR)

ATR measures the stock volatility by comparing the current value with the previous value. To render a Average True Range (ATR) Indicator, use indicator type as Atr and inject AtrIndicatorService into the @NgModule.providers.

Bollinger Band

A StockChart overlay that shows the upper and lower limits of normal price movements based on the standard deviation of prices.
To render a Bollinger Band, use indicator type as BollingerBand and inject BollingerBandsService into the @NgModule.providers.
Bollinger band will be represented by three lines (upperLine, lowerLine, signalLine).Bollinger Band default values of the period is 14 and standardDeviations is 2.

Exponential Moving Average (EMA)

Moving average Indicators are used to define the direction of the trend. To render a EMA Indicator, use indicator type as Ema and inject EMAIndicatorService into the @NgModule.providers.

Momentum

Momentum shows the speed at which the price of the stock is changing. To render a Momentum indicator, use indicator type as Momentumand inject MomentumIndicatorService into the @NgModule.providers. Momentum indicator will be represented by two lines (upperLine, signalLine).In momentum indicator the upperBand value is always render at the value 100.

Moving Average Convergence Divergence (MACD)

MACD is based on the difference between two EMA’s. To render a MACD Indicator, use indicator type as MACD and inject MACDIndicatorService into the @NgModule.providers.MACD indicator will be represented by MACD line,signal line, MACD histogram. MACD histogram is used to differentiate MACD line and signal line.

Relative Strength Index (RSI)

RSI shows how strongly a stock is moving in its current direction. To render a RSI Indicator, use indicator type asRsi and inject RsiIndicatorService into the @NgModule.providers.RSI indicator will be represented by three lines (upperBand, lowerBand, signalLine). The upperBand and lowerBand values are customized by overBought and overSold properties of indicator and the signalLine is calculated by RSI formula.

Simple Moving Average (SMA)

Moving average Indicators are used to define the direction of the trend. To render a SMA Indicator, use indicator type as Sma and inject SmaIndicatorService module using @NgModule.providers.

Stochastic

It shows how a stock is, when compared to previous state. To render a Stochastic indicator, use indicator type as Stochastic and inject StochasticIndicatorService module using @NgModule.providers method.
stochastic indicator will be represented by four lines (upperLine, lowerLine, periodLine, signalLine).
In stochastic indicator the upperBand value and lowerBand value is customized by overBought and overSold properties of indicators and the periodLine and signalLine is render based on stochastic formula.

Triangular Moving Average (TMA)

Moving average indicators are used to define the direction of the trend. To render a TMA Indicator, use indicator type as TMA and inject TmaIndicatorService module using @NgModule.providers.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule, StockChartAllModule } from '@syncfusion/ej2-angular-charts'
import { CandleSeriesService, LineSeriesService, TmaIndicatorService, DateTimeService} from '@syncfusion/ej2-angular-charts'



import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { chartData } from './datasource';

@Component({
imports: [
         ChartModule, StockChartAllModule
    ],

providers: [ CandleSeriesService, LineSeriesService, TmaIndicatorService, DateTimeService],
standalone: true,
    selector: 'app-container',
    template:
            `<ejs-stockchart id='chartcontainer' style="display:block;" [title]='title' [primaryXAxis]='primaryXAxis' [primaryYAxis]='primaryYAxis'
              [chartArea]= 'chartArea'>
            <e-stockchart-indicators>
                <e-stockchart-indicator type='Tma' [dataSource]='data' xName='x' field="Close" high='high' low='low' open='open' fill="blue"
                close='close' volume='volume'> </e-stockchart-indicator>
            </e-stockchart-indicators>
        </ejs-stockchart>`
})
export class AppComponent implements OnInit {
 public data: Object[] = chartData;
    public primaryXAxis: Object = {
        title: 'Months',
        valueType: 'DateTime',
        intervalType: 'Months',
        majorGridLines: { width: 0}
    };
    public primaryYAxis: Object = {
        title: 'Price',
        labelFormat: '${value}',
        minimum: 30, maximum: 180,
        interval: 30,
    };
    public title: string = 'AAPL 2012-2017';
    public chartArea : Object = {
      border: { width : 0}
    };
    constructor() {
        //code
    } ngOnInit(): void {
        throw new Error('Method not implemented.');
    }
;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Indicator Events

The StockChart component supports indicator life cycle events, allowing you to monitor and control indicator add and remove operations triggered through the built-in toolbar indicator dropdown. These events are useful for validating user actions, restricting specific indicators, tracking indicator changes, and integrating indicator interactions with application logic.

The following indicator events are supported by the StockChart component:

  • beforeIndicatorChange – Fired before an indicator is added or removed. This event allows you to review the requested action in advance and cancel it by setting cancel to true.

  • indicatorChanged – Fired after an indicator has been added or removed successfully. This event occurs only if the action was not canceled and can be used to handle the updated state in your application.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartAllModule, StockChartModule } from '@syncfusion/ej2-angular-charts';
import { CandleSeriesService, LineSeriesService, SplineSeriesService, DateTimeService, TooltipService, CrosshairService,
    IBeforeIndicatorChangeEventArgs, IIndicatorChangedEventArgs } from '@syncfusion/ej2-angular-charts';


    
import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { chartData } from './datasource';

@Component({
    selector: 'app-container',
    encapsulation: ViewEncapsulation.None,
    imports: [ChartAllModule, StockChartModule],
    providers: [CandleSeriesService, LineSeriesService, SplineSeriesService, DateTimeService, TooltipService, CrosshairService],
    standalone: true,
    template: `
        <ejs-stockchart id="chartcontainer" [title]="title" [primaryXAxis]="primaryXAxis" [tooltip]="tooltip" [crosshair]="crosshair"
        (beforeIndicatorChange)="beforeIndicatorChange($event)" (indicatorChanged)="indicatorChanged($event)">
        <e-stockchart-series-collection>
            <e-stockchart-series [dataSource]="stockData" type="Candle" xName="date" open="open" high="high" low="low" close="close" 
            volume="volume" name="Apple Inc">
            </e-stockchart-series>
        </e-stockchart-series-collection>
        </ejs-stockchart>
    `
})
export class AppComponent implements OnInit {
    public title?: string;
    public primaryXAxis?: Object;
    public stockData?: Object[];
    public tooltip?: Object;
    public crosshair?: Object;
  
    ngOnInit(): void {
        this.stockData = chartData;
        this.title = 'AAPL Stock Price';
        this.primaryXAxis = {
        valueType: 'DateTime',
        };
        this.tooltip = { enable: true };
        this.crosshair = { enable: true };
    }

    public beforeIndicatorChange(args: IBeforeIndicatorChangeEventArgs): void {
        console.log('Before Indicator Change:', args.type);
        // Prevent EMA indicator
        if (args.type === 'Ema') {
           args.cancel = true;
        }
    }
    public indicatorChanged(args: IIndicatorChangedEventArgs): void {
        console.log(`${args.type} indicator ${args.isAdd ? 'added' : 'removed'}`);
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Module Dependencies
To render a Indicator, it is mandatory to inject LineSeriesService module..
In addition to that, MACD Indicator requires ColumnSeriesService and BollingerBands requires RangeAreaSeriesService.

Technical indicators in Vue Stock chart component

18 Nov 201815 minutes to read

A technical indicator is a mathematical calculation based on historic price, volume or open interest information that aims to forecast financial market direction.

StockChart supports 10 types of technical indicators namely Accumulation Distribution, ATR, EMA,SMA,TMA,Momentum,MACD,RSI,Stochastic,Bollinger Band. By using indicator dropdown box you can add an remove the required indicators types.

Accumulation Distribution

Accumulation Distribution combines price and volume to show how money may be flowing into or out of stock.
To render a Accumulation Distribution Indicator, use indicator type as AccumulationDistribution and inject AccumulationDistributionIndicator into the provide. To calculate the signal line volume field is additionally added with dataSource.

Average True Range (ATR)

ATR measures the stock volatility by comparing the current value with the previous value. To render a Average True Range (ATR) Indicator, use indicator type as Atr and inject AtrIndicator into the provide.

Exponential Moving Average (EMA)

Moving average Indicators are used to define the direction of the trend. To render a EMA Indicator,
use indicator type as Ema and inject EmaIndicator into the provide.

Momentum

Momentum shows the speed at which the price of the stock is changing. To render a Momentum indicator, use indicator type as Momentumand inject MomentumIndicator into the provide. Momentum indicator will be represented by two lines (upperLine,
signalLine).In momentum indicator the upperBand value is always renders at the value 100.

Moving Average Convergence Divergence (MACD)

MACD is based on the difference between two EMA’s. To render a MACD Indicator, use indicator type as Macd and inject MacdIndicator into the provide.MACD indicator will be represented by MACD line,signal line, MACD histogram. MACD histogram is used to differentiate MACD line and signal line.

Relative Strength Index (RSI)

RSI shows how strongly a stock is moving in its current direction. To render a RSI Indicator, use indicator type as Rsi and inject RsiIndicator into the provide.RSI indicator will be represented by three lines (upperBand, lowerBand, signalLine). The upperBand and lowerBand values are customized by overBought and overSold properties of indicator and the signalLine is calculated by RSI formula.

Simple Moving Average (SMA)

Moving average Indicators are used to define the direction of the trend. To render a SMA Indicator, use indicator type as Sma and inject SmaIndicator into the provide.

Stochastic

It shows how a stock is, when compared to previous state. To render a Stochastic indicator, use indicator type as Stochastic and inject StochasticIndicator into the provide. stochastic indicator will be represented by four lines (upperLine, lowerLine, periodLine, signalLine). In stochastic indicator the upperBand value and lowerBand value is customized by overBought and overSold properties of indicators and the periodLine and signalLine is render based on stochastic formula.

Triangular Moving Average (TMA)

Moving average Indicators are used to define the direction of the trend. To render a TMA Indicator, use indicator type as Tma and inject TmaIndicator into the provide.

Bollinger Band

A StockChart overlay that shows the upper and lower limits of normal price movements based on the standard deviation of prices. To render a Bollinger Band, use indicator type as BollingerBand and inject BollingerBands into the provide.
Bollinger band will be represented by three lines (upperLine, lowerLine, signalLine).The default values of the Bollinger Band period is 14 and standardDeviations is 2.

<template>
  <div class="control-section">
    <div>
      <ejs-stockchart id="stockchartcontainer" :primaryXAxis="primaryXAxis" :primaryYAxis="primaryYAxis"
        :seriesType="seriesType" :trendlineType="trendlineType" :exportType="exportType" :title="title">
        <e-stockchart-series-collection>
          <e-stockchart-series :dataSource="seriesData" type="Candle" volume='volume' xName='date' low='low' high='high'
            open='open' close='close'></e-stockchart-series>
        </e-stockchart-series-collection>
      </ejs-stockchart>
    </div>
  </div>
</template>
<script setup>
import { provide } from "vue";

import { chartData } from "./datasource.js";
import {
  StockChartComponent as EjsStockchart, StockChartSeriesCollectionDirective as EStockchartSeriesCollection, StockChartSeriesDirective as EStockchartSeries, DateTime, CandleSeries, RangeTooltip, RangeAreaSeries, Logarithmic, Zoom,
  EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator
} from "@syncfusion/ej2-vue-charts"

const seriesData = chartData;
const primaryXAxis = {
  valueType: "DateTime",
  majorGridLines: { color: "transparent" },
};
const primaryYAxis = {
  majorTickLines: { color: "transparent", width: 0 }
};
const seriesType = [];
const trendlineType = [];
const exportType = [];
const title = 'AAPL Stock Price';


provide('stockChart', [
  DateTime, RangeTooltip, CandleSeries, EmaIndicator, RsiIndicator, RangeAreaSeries, Logarithmic, Zoom,
  BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator
]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div class="control-section">
    <div>
      <ejs-stockchart id="stockchartcontainer" :primaryXAxis="primaryXAxis" :primaryYAxis="primaryYAxis"
        :seriesType="seriesType" :trendlineType="trendlineType" :exportType="exportType" :title="title">
        <e-stockchart-series-collection>
          <e-stockchart-series :dataSource="seriesData" type="Candle" volume='volume' xName='date' low='low' high='high'
            open='open' close='close'></e-stockchart-series>
        </e-stockchart-series-collection>
      </ejs-stockchart>
    </div>
  </div>
</template>
<script>

import { chartData } from "./datasource.js";
import {
  StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, DateTime, CandleSeries, RangeTooltip, RangeAreaSeries, Logarithmic, Zoom,
  EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator
} from "@syncfusion/ej2-vue-charts"

export default {
  name: "App",
  components: {
    'ejs-stockchart': StockChartComponent,
    'e-stockchart-series-collection': StockChartSeriesCollectionDirective,
    'e-stockchart-series': StockChartSeriesDirective
  },
  data() {
    return {
      seriesData: chartData,
      primaryXAxis: {
        valueType: "DateTime",
        majorGridLines: { color: "transparent" },
      },
      primaryYAxis: {
        majorTickLines: { color: "transparent", width: 0 }
      },
      seriesType: [],
      trendlineType: [],
      exportType: [],
      title: 'AAPL Stock Price',
    };
  },
  provide: {
    stockChart: [
      DateTime, RangeTooltip, CandleSeries, EmaIndicator, RsiIndicator, RangeAreaSeries, Logarithmic, Zoom,
      BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator
    ]
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Indicator Events

The StockChart component supports indicator life cycle events, allowing you to monitor and control indicator add and remove operations triggered through the built-in toolbar indicator dropdown. These events are useful for validating user actions, restricting specific indicators, tracking indicator changes, and integrating indicator interactions with application logic.

The following indicator events are supported by the StockChart component:

  • beforeIndicatorChange – Fired before an indicator is added or removed. This event allows you to review the requested action in advance and cancel it by setting cancel to true.

  • indicatorChanged – Fired after an indicator has been added or removed successfully. This event occurs only if the action was not canceled and can be used to handle the updated state in your application.

<template>
  <div class="control-section">
    <div>
      <ejs-stockchart id="stockchartcontainer" :primaryXAxis="primaryXAxis" :tooltip="tooltip"
        :crosshair="crosshair" :title="title" :beforeIndicatorChange="beforeIndicatorChange" :indicatorChanged="indicatorChanged">
        <e-stockchart-series-collection>
          <e-stockchart-series :dataSource="seriesData" type="Candle" xName="date" open="open" high="high" low="low" close="close"
            volume="volume" name="Apple Inc">
          </e-stockchart-series>
        </e-stockchart-series-collection>
      </ejs-stockchart>
    </div>
  </div>
</template>

<script setup>
import { provide } from "vue";
import { chartData } from "./datasource.js";
import {
  StockChartComponent as EjsStockchart, StockChartSeriesCollectionDirective as EStockchartSeriesCollection, StockChartSeriesDirective as EStockchartSeries,
  DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, LineSeries, SplineSeries, AccumulationDistributionIndicator, AtrIndicator, BollingerBands,
  EmaIndicator, MomentumIndicator, MacdIndicator, RsiIndicator, SmaIndicator, StochasticIndicator, TmaIndicator
} from "@syncfusion/ej2-vue-charts";

const seriesData = chartData;
const title = "AAPL Stock Price";
const primaryXAxis = {
  valueType: "DateTime"
};
const tooltip = {
  enable: true
};
const crosshair = {
  enable: true
};
const beforeIndicatorChange = (args) => {
  console.log("Before Indicator Change:", args.type);
  // Prevent EMA indicator
  if (args.type === "Ema") {
    args.cancel = true;
  }
};
const indicatorChanged = (args) => {
  console.log(`${args.type} indicator ${args.isAdd ? "added" : "removed"}`);
};


provide("stockChart",[ 
  DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, LineSeries, SplineSeries, AccumulationDistributionIndicator, AtrIndicator, BollingerBands, EmaIndicator,
  MomentumIndicator, MacdIndicator, RsiIndicator, SmaIndicator, StochasticIndicator, TmaIndicator 
]);
</script>

<style>
.control-section {
  height: 350px;
}
</style>
<template>
  <div class="control-section">
    <div>
      <ejs-stockchart id="stockchartcontainer" :primaryXAxis="primaryXAxis" :tooltip="tooltip"
        :crosshair="crosshair" :title="title" :beforeIndicatorChange="beforeIndicatorChange" :indicatorChanged="indicatorChanged">
        <e-stockchart-series-collection>
          <e-stockchart-series :dataSource="seriesData" type="Candle" xName="date" open="open" high="high" low="low" close="close"
            volume="volume" name="Apple Inc">
          </e-stockchart-series>
        </e-stockchart-series-collection>
      </ejs-stockchart>
    </div>
  </div>
</template>

<script>
import { chartData } from "./datasource.js";
import {
  StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, LineSeries,
  SplineSeries, AccumulationDistributionIndicator, AtrIndicator, BollingerBands, EmaIndicator, MomentumIndicator, MacdIndicator, RsiIndicator,
  SmaIndicator, StochasticIndicator, TmaIndicator
} from "@syncfusion/ej2-vue-charts";

export default {
  name: "App",
  components: {
    "ejs-stockchart": StockChartComponent,
    "e-stockchart-series-collection": StockChartSeriesCollectionDirective,
    "e-stockchart-series": StockChartSeriesDirective
  },
  data() {
    return {
      seriesData: chartData,
      title: "AAPL Stock Price",
      primaryXAxis: {
        valueType: "DateTime"
      },
      tooltip: {
        enable: true
      },
      crosshair: {
        enable: true
      },
    };
  },
  methods: {
    beforeIndicatorChange(args) {
      console.log("Before Indicator Change:", args.type);
      // Prevent EMA indicator
      if (args.type === "Ema") {
        args.cancel = true;
      }
    },
    indicatorChanged(args) {
      console.log(`${args.type} indicator ${args.isAdd ? "added" : "removed"}`);
    }
  },
  provide: {
    stockChart: [ DateTime, Tooltip, RangeTooltip, Crosshair, CandleSeries, LineSeries, SplineSeries, AccumulationDistributionIndicator, AtrIndicator, BollingerBands, EmaIndicator,
      MomentumIndicator, MacdIndicator, RsiIndicator, SmaIndicator, StochasticIndicator, TmaIndicator ]
  }
};
</script>

<style>
.control-section {
  height: 350px;
}
</style>